<template>
    <div v-if="isLoading" class="flex w-full h-full">
        <div v-loading="isLoading" class="w-full px-5 py-32"></div>
    </div>
    <template v-else>
        <div v-if="!isBankMethodAvailabled" class="px-5 py-32 text-2xl flex justify-center">
            <span>{{ $t("no_available_method_to_do_the_transaction") }}</span>
        </div>
        <template v-else>
            <div v-if="!isLoading && !isShowPaymentPasswordDialog" class="flex divider-x relative mx-auto">
                <aside class="min-w-[248px] w-3/12">
                    <el-scrollbar>
                        <div class="p-6 flex flex-col gap-4">
                            <template v-for="tab in methodTabs" :key="tab.to">
                                <nuxt-link v-if="tab.display" :to="tab.to" :class="{ selected: checkActiveLink(tab.to) }">
                                    <ui-check-button :text="$t(tab.label)" :img="tab.icon" />
                                </nuxt-link>
                            </template>
                        </div>
                    </el-scrollbar>
                </aside>
                <el-scrollbar class="w-9/12" height="724px">
                    <div class=" divider-y right-content">
                        <!-- <nuxt-page :payment-banks="paymentBanks" :normal-banks="normalBanks" :profile="profile"
                            :is-withdrawal-limit-enabled="isWithdrawalLimitEnabled"
                            :is-payment-password-enable="isPaymentPasswordEnable">
                        </nuxt-page> -->
                        <lazy-theme-common-desktop-payment-withdrawal-crypto-currency-withdrawal 
                            :normal-banks="normalBanks" :payment-banks="paymentBanks" :profile="profile"
                            :is-payment-password-enable="isPaymentPasswordEnable"
                            :is-withdrawal-limit-enabled="isWithdrawalLimitEnabled"
                            v-if="$route.fullPath.includes('uc=/withdrawal/payment-bank/cryptocurrency')" />
                        <payment-bank-transfer-withdrawal
                            :normal-banks="normalBanks" :payment-banks="paymentBanks" :profile="profile"
                            :is-payment-password-enable="isPaymentPasswordEnable"
                            :is-withdrawal-limit-enabled="isWithdrawalLimitEnabled"
                            v-if="!$route.fullPath.includes('uc=/withdrawal/payment-bank/cryptocurrency') && $route.fullPath.includes('uc=/withdrawal/payment-bank/')" />
                        <lazy-theme-common-desktop-payment-withdrawal-normal-bank-transfer-withdrawal
                            :normal-banks="normalBanks" :payment-banks="paymentBanks" :profile="profile"
                            :is-payment-password-enable="isPaymentPasswordEnable"
                            :is-withdrawal-limit-enabled="isWithdrawalLimitEnabled"
                            v-if="$route.fullPath.includes('uc=/withdrawal/bank-transfer')" />
                    </div>
                </el-scrollbar>
            </div>
        </template>
    </template>
    <el-dialog v-model="isShowPaymentPasswordDialog" :show-close="false" :close-on-click-modal="false" width="40%"
        custom-class="no-header">
        <div class="mb-4" style="word-break: break-word">
            {{ alertMessage }}
        </div>
        <div>
            <el-form ref="ruleFormRef" label-position="left" label-width="200px" :model="formData" :rules="getRule"
                style="max-width: 550px" :validate-on-rule-change="false">
                <el-form-item :label="paymentPasswordLabel" prop="paymentPassword">
                    <el-input v-model="formData.paymentPassword" type="password" />
                </el-form-item>
                <el-form-item :label="confirmPaymentPasswordLabel" prop="confirmPaymentPassword">
                    <el-input v-model="formData.confirmPaymentPassword" type="password" />
                </el-form-item>
                <el-form-item :label="loginPasswordLabel" prop="loginPassword">
                    <el-input v-model="formData.loginPassword" type="password" />
                </el-form-item>
            </el-form>
        </div>
        <template #footer>
            <span class="dialog-footer">
                <div class="text-center">
                    <el-button type="danger" round @click="onCancel">{{
                        $t("cancel")
                    }}</el-button>
                    <el-button type="primary" round @click="submitWithdrawal(ruleFormRef)">{{ $t("submit") }}</el-button>
                </div>
            </span>
        </template>
    </el-dialog>
</template>
  
<script lang="ts" setup>
import commonHelper from "@/utils/commonHelper";
import { store } from "~~/store";
import PaymentBankTransferWithdrawal from "~~/components/theme/common/desktop/payment/withdrawal/payment-bank-transfer-withdrawal.client.vue";
const {
    paymentBanks,
    normalBanks,
    isNormalBankMethodValible,
    isPaymentBankMethodValible,
    paymentPasswordLabel,
    confirmPaymentPasswordLabel,
    loginPasswordLabel,
    alertMessage,
    formData,
    isShowPaymentPasswordDialog,
    submitWithdrawal,
    getRule,
    ruleFormRef,
    isPaymentPasswordEnable,
    profile,
    isWithdrawalLimitEnabled,
    isLoading,
    isBankMethodAvailabled,
    onCancel,
} = useWithdrawal();
const { getAssetImage } = commonHelper;
const isSbo = computed(() => store.state.selectedThemeName === "sbo");

const methodTabs = ref<TDepositTab[]>([]);
const route = useRoute();
watch(() => [paymentBanks.value, isPaymentBankMethodValible.value, isNormalBankMethodValible.value], () => {
    methodTabs.value = [];
    if (isPaymentBankMethodValible.value) {
        paymentBanks.value.PaymentMethodsForWithdrawal.forEach((paymentMethod: IPaymentMethodsForDepositAndWithdrawal) => {
            methodTabs.value.push({
                to: `${route.path}?uc=/withdrawal/payment-bank/${paymentMethod.PaymentMethod}`,
                label: paymentMethod.PaymentMethodDisplayName,
                icon: paymentMethod.PaymentMethodIconUrl,
                display: isPaymentBankMethodValible.value,
            });
        });
    }
    if (isNormalBankMethodValible.value) {
        methodTabs.value.push({
            to: `${route.path}?uc=/withdrawal/bank-transfer`,
            label: "bank_transfer",
            icon: getAssetImage('assets/materials/paymentMethod/icon-bank-transfer@2x.png'),
            display: isNormalBankMethodValible.value,
        });
    }
})
const checkActiveLink = (link: string) => {
    return String(route.query?.uc) === link.replace('/?uc=', '');
};
</script>
<style>
.blank-dialog[layout="global"] .right-content .el-form-item__label {
    color: var(--text5);
}
</style>
<style scoped>
.uc-section :deep(.el-input__inner),
.uc-section :deep(.el-input.is-disabled .el-input__inner),
.uc-section :deep(.el-input-group__append) {
    background-color: rgba(0, 0, 0, 0.1);
    color: var(--text5);
}

:deep(.company-bank-account .el-input__wrapper) {
    width: 98%;
}

.uc-section :deep(.company-bank-account-container .el-input-group__append) {
    background-color: var(--primary);
    border: unset;
    border-radius: 4px;
    box-shadow: none;
}

.uc-section :deep(.el-form-item__label) {
    color: var(--text5);
}

:deep(.el-radio-button .check-img) {
    bottom: 17px;
}
</style>
  